/*
*********************************************************************************
*                                                                               *
* NOTICE:                                                                       *
* This document contains information that is confidential and proprietary to    *
* RADVision LTD.. No part of this publication may be reproduced in any form     *
* whatsoever without written prior approval by RADVision LTD..                  *
*                                                                               * 
* RADVision LTD. reserves the right to revise this publication and make changes *
* without obligation to notify any person of such revisions or changes.         *    
* Copyright RADVision 1996.                                                     *
* Last Revision: Jan. 2000                                                      *
*********************************************************************************
*/




/**********************************************************
    	 PUBLIC  DECLARATIONS
*=========================================================
* TITLE: islands.h
*---------------------------------------------------------
* PROJECT: GK CONFIGURATION FOR PC
*---------------------------------------------------------
* $Workfile$
*---------------------------------------------------------
* $Author$ NATHANIEL LEIBOWITZ and OFER SHAPIRO
*---------------------------------------------------------
* $Date$ 13/3/97
*---------------------------------------------------------
* $Revision$
**********************************************************/



/*------------------*/
/* PUBLIC CONSTANTS */
/*------------------*/

#define USER_MSG_RECEIVED_EVENT         WM_USER+1
#define USER_MSG_BYPASS_APP             WM_USER+2
#define USER_MSG_CONSULT_APP            WM_USER+3
#define USER_MSG_RECEIVED_CALL_EVENT    WM_USER+4

#define USER_MSG_BYPASS_APP_FOR_CALLS   WM_USER+5
#define USER_MSG_CONSULT_APP_FOR_CALLS  WM_USER+6
#define CALLS_RECEIVED_CALL_EVENT       WM_USER+7
#define USER_MSG_EVENT_FOR_THIS_WINDOW  WM_USER+8

#define USER_MSG_RECEIVED_BANDWIDTH_EVENT         WM_USER+9
#ifdef GKSUS_PLUGIN
#define USER_MSG_GKSUS_EVENT            WM_USER+10
#endif

#define APPUTIL_WINDOW_LRQHANDLE_FIELD "LRQHandle"
#define APPUTIL_WINDOW_LRQMSG_TYPE_FIELD "LRQMessageType"
/*-------------*/
/* PUBLIC TYPE */
/*-------------*/

typedef enum {GKWIN_CONFIRM,GKWIN_REJECT,GKWIN_CONTINUE,GKWIN_DELETE,GKWIN_KEEP,
              GKWIN_NONE, GKWIN_START_ADDRESS_RESOLUTION, GKWIN_OVLP,
              GKWIN_LRQ_CONFIRM,GKWIN_LRQ_REJECT,GKWIN_LRQ_CONTINUE} gkwinResponse_t;
typedef enum {GKWIN_RSN_NONE,GKWIN_RSN_IP,GKWIN_RSN_ALIAS} gkwinResponseReason_t;
typedef enum {APPUTIL_APPREG_NULL=1,APPUTIL_APPREG_OPEN_WINDOW} gkHAPPRegEnum_t;

typedef struct
{
  gkHREG            hReg;
  gkHAPPREG*        haReg;
  gkHLRQ            hLRQ;
  gkHAPPLRQ*        haLRQ;
  gkrgiEvent_t      event;
} apputilDBParamStruct;

/*
typedef struct {
  gkHCALL hCall;
  gkcciState_t  callState;
  gkcciReason_t callReason;
} apputilCallParam_t;
*/
typedef struct {
  gkwinResponse_t       response;
  gkcciState_t          state;
  gkwinResponseReason_t reason;
} apputilCallReply_t;
/*------------------*/
/* PUBLIC VARIABLES */
/*------------------*/

apputilCallReply_t callReply;

/*------------------*/
/* PUBLIC FUNCTIONS */
/*------------------*/

INT32 apputilHandler(HWND wHnd,INT32 error,char* notification);

HWND apputilFindLRQWindow(/*returns handle of the window associated with the supplied parameters.
                          If none found, NILL is returned*/
                          IN gkHAPPLRQ* windowId,
                          IN gkHLRQ     authentication);

BOOL apputilGetLRQHandle(IN HWND hWnd,OUT gkHLRQ* hLRQ);

BOOL apputilGetLRQMsgType(IN HWND hWnd,OUT gklrqiMessage_t* msg);

BOOL apputilSetLRQHandle(IN HWND hWnd,IN gkHLRQ hLRQ);

BOOL apputilSetLRQMsgType(IN HWND hWnd,IN gklrqiMessage_t msg);

void apputilExchangeLRQAndWndHandles(
                                      IN HWND     hWnd,
                                      IN gkHLRQ   hLRQ);

BOOL apputilFreeLRQAndEndDialog(HWND hWnd,gkwinResponse_t response,gklrqiReplyReason_t reason);

BOOL apputilFreeAndCloseNSDialog(HWND hWnd);

void apputilHandleEventForThisWindow(IN HWND    hWnd,
                                     IN gkHLRQ  hLRQ);

BOOL apputilCloseWindow(HWND tempHWnd,gkwinResponse_t response,gkrgiReplyReason_t replyRsn, HWND* permanentHWnd);

INT32 apputilIpStringToIpNum(/*converts a string with ip in format ddd.ddd.ddd.ddd to its numerical value.
                            NOTE ipString is not checked to be a valid ipString*/
                            IN char * ipString);

BOOL apputilTypeName2TypeVal(OUT gkaddEndpointType* typeVal, IN char* typeName);

char* apputilIpNumToIpString(/*converts numerical ip format to string format "ddd.ddd.ddd.ddd".
                            If successful returns address of satitcally allocated buffer of the string.
                            Non Re-entrant*/
                            IN INT32 ip);

char* apputilAppTransportToString(/*converts numerical ip format and numerical port to string format "ddd.ddd.ddd.ddd:port".
                                If successful returns address of satitcally allocated buffer of the string.
                                Non Re-entrant*/
                                IN gkaddTransport_t * trans);
//SARAH
BOOL apputilStringToAppTransport (/* converts transport string in the format of ddd.ddd.ddd.ddd:port
                                     to application transport structure. The routien does not fill
                                     the route fields */
                                     IN char *transString, OUT gkaddTransport_t* trans);

RVAPI char* CALLCONV apputilNumToString(/*converts number 'num' to its string equivalent.
                                       Limited to num whose string is 10 chars or less.
                                       If successful returns address of satitcally allocated buffer of the string.
                                       Non Re-entrant*/
                                       IN INT32 num);
//SARAH
/* converts string to num. caller should verify that str is not NULL
   before calling this function */
RVAPI INT32 CALLCONV apputilStringToNum(IN char *str);

RVAPI INT32 CALLCONV apputilValidIpString(/*positive if 'ipString' is a valid i.p. string in format ddd.ddd.ddd.ddd.
                                         otherwise negative value is returned*/
                                         IN char * ipString);

RVAPI INT32 apputilValidPort(/*positive if port is a valid port number*/
                                   IN INT32 port);


BOOL apputilHitTestItem(/*performs the hit_Test. If successful return value is true, and 
                         lvItem->iItem will contatin the item that was hit.otherwise FALSE is returned*/
                         IN HWND hList,
                         OUT LV_ITEM *lvItem);

LPARAM apputilgetSelectedLParam(/*returns value of the lPAram field of the selected item in the endpoints list.
                                  If none selected, -1 is returned*/
                                  IN HWND hList);

int apputilFindItemByLParam(/*returns item number of the item whose LPAram value is lParam.
                        if  none found -1 is returned*/
                        IN HWND hList,
                        IN LPARAM lParam);

BOOL apputilIsDynamic(/*an easy interface for the gkrgiIsDynamic.
                      Note that information on error values is lost*/
                      IN gkHREG hReg);

BOOL apputilIsStatic(/*an easy interface for the gkrgiIsStatic.
                      Note that information on error values is lost*/
                      IN gkHREG hReg);

BOOL apputilIsForcedDynamic(/*an easy interface for the determining value of forcedDynamic flag.
                              Note that information on error values is lost*/
                              IN gkHREG hReg);
char* apputilCallNum2CallNumStr( /* translate the call number to a string,
                                  output string is valid till next call */
                                  IN gktypeCallNum_t callNum);

char* apputilConfGoal2ConfGoalStr( /* translate the conference goal to a string */
                                  IN gktypeConferenceGoal_t confGoal);

char* apputilCallModel2CallModelStr( /* translate the call model to a string */
                                   IN gktypeCallModel_t callModel);

char* apputilCid2CidStr(/* translate cid to string */
                        IN gktypeCid_t cid );

char* apputilCallID2CallIDStr(/* translate callID to string */
                  IN gktypeCallID_t callID );

BOOL apputilEmptyName( /*TRUE if variable name is empty*/
                               IN gkaddName_t name);

BOOL apputilEmptyPhone( /*TRUE if variable phone is empty*/
                               IN gkaddPhone_t phone);

BOOL apputilEmptyTransport( /*TRUE if variable trans is empty*/
                               IN gkaddTransport_t *trans);

void apputilResetTransport(/*reset the transport address to the empty address */
                                    IN gkaddTransport_t *appIp);

void apputilResetName(/*reset the name alias to the empty alias */
                               IN gkaddName_t  appName);

void apputilResetPhone(/*reset the phone alias to the empty alias */
                                gkaddPhone_t  appPhone);

BOOL apputilEmptyAlias( /*TRUE if variable alias is empty*/
                               IN gkaddAlias_t *alias);

void apputilResetAlias(/*reset the alias to the empty alias */
                               IN gkaddAlias_t  *alias);

BOOL apptypesEmptyNonStandardParam(/*TRUE if variable trans is empty*/
                                          IN gktypeNonStandardParam* nsParam);

void apptypesResetNonStandardParam(/*reset the nsParam to an empty one*/
                                         IN gktypeNonStandardParam* nsParam);

int CALLBACK apputilEndpSrvcsCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

int CALLBACK apputilSrvcTableCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

BOOL apputilIsPrefix(/* TRUE if the alias given is a prefix of an existing alias in the registration table */
                     IN gkaddPhone_t alias,
                     OUT BOOL *equal);
