/*
*********************************************************************************
*                                                                               *
* NOTICE:                                                                       *
* This document contains information that is confidential and proprietary to    *
* RADVision LTD.. No part of this publication may be reproduced in any form     *
* whatsoever without written prior approval by RADVision LTD..                  *
*                                                                               * 
* RADVision LTD. reserves the right to revise this publication and make changes *
* without obligation to notify any person of such revisions or changes.         *    
* Copyright RADVision 1996.                                                     *
* Last Revision: Jan. 2000                                                      *
*********************************************************************************
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#endif

#include <cm.h>

#include "resource.h"

#include "rvcommon.h"
#include "mci_types.h"
#include "mci_report.h"
#include "mci_general.h"

#include "gkadd.h"
#include "gkrgi.h"
#include "gkcci.h"

#include "mci_chan.h"
#include "mci_call.h"
#include "mci_conf.h"
#include "mci_mc.h"
#include "mci_call_caps.h"

#include "gkmc.h"
#include "mcgki.h"
#include "mcconfig.h"
#include "mcmain.h"

#include "mccall_details.h"
#include "mcrefresh.h"

//3.11
static mciConfHandleType CURRENT_CONF_HANDLE=0;
static mciCallHandleType CURRENT_CALL_HANDLE=0;
static mciChanHandleType CURRENT_CHAN_HANDLE=0;

static HWND CONFERENCES_HANDLE;
static HWND CONF_DETAIL_HANDLE;
static HWND CALL_DETAIL_HANDLE;
static HWND CHAN_CONTROL_HANDLE;
//

static int CURRENT_DIALOG;
static int CURRENT_HANDLE; //to a conf,a call or a channel
static HWND GLOBALHWND;



/**************************************************************************/
/*send refersh message if the event is relevant to the active dialog*/
void RefreshConferencesListDialog()
{
	HWND hWnd;
/*refreshing the conferences dialog*/
	getCONFERENCES_HANDLE(&hWnd);
	if(hWnd)
		PostMessage(hWnd,WM_REFRESH_DIALOG,0,0);
}

/**************************************************************************/
/*send refersh message if the event is relevant to the active dialog*/
void RefreshConfDialog(mciConfHandleType hConf,BOOL invalidHandle)
{
	HWND hWnd;
	mciConfHandleType hCurrentConf;

	RefreshConferencesListDialog();

/*refreshing the current conf dialog*/
	getCURRENT_CONF_HANDLE(&hCurrentConf);
	getCONF_DETAIL_HANDLE(&hWnd);
	if((hWnd)&&(hConf==hCurrentConf))
		if(invalidHandle)
			SendMessage(hWnd,WM_CLOSE,0,0);
		else
			PostMessage(hWnd,WM_REFRESH_DIALOG,0,0);
}


/**************************************************************************/
/*send refersh message if the event is relevant to the active dialog*/
void RefreshCallDialog(mciCallHandleType hCall,BOOL invalidHandle)
{
	HWND hWnd;
	mciCallHandleType hCurrentCall=0;
	mciConfHandleType hCallFather=0;

	getCURRENT_CALL_HANDLE(&hCurrentCall);
	getCALL_DETAIL_HANDLE(&hWnd);
	if((hWnd)&&(hCall==hCurrentCall))
		if(invalidHandle)
			SendMessage(hWnd,WM_CLOSE,0,0);
		else
			PostMessage(hWnd,WM_REFRESH_DIALOG,0,0);
	//refresh the other dialogs, if necessary
	mciCallGetConf(hCall,&hCallFather);
	RefreshConfDialog(hCallFather,VALID_HANDLE);
}

void RefreshChanDialog(mciChanHandleType hChan,BOOL invalidHandle)
{
	HWND hWnd;
	mciChanHandleType hCurrentChan=0;
	mciCallHandleType hChanFather=0;

	getCURRENT_CHAN_HANDLE(&hCurrentChan);
	getCHAN_CONTROL_HANDLE(&hWnd);
	if((hWnd)&&(hChan==hCurrentChan))
		if(invalidHandle)
 		    SendMessage(hWnd,WM_CLOSE,0,0);
		else
			PostMessage(hWnd,WM_REFRESH_DIALOG,0,0);
	//refresh the other dialogs, if necessary
	mciChanGetCall(hChan,&hChanFather);
	RefreshCallDialog(hChanFather,VALID_HANDLE);
}


//3.11
void setCURRENT_CONF_HANDLE(mciConfHandleType confHandle)
{	CURRENT_CONF_HANDLE=confHandle;		}
void getCURRENT_CONF_HANDLE(mciConfHandleType  * confHandle)
{	*confHandle=CURRENT_CONF_HANDLE;	}

void setCURRENT_CALL_HANDLE(mciCallHandleType callHandle)
{	CURRENT_CALL_HANDLE=callHandle;		}
void getCURRENT_CALL_HANDLE(mciCallHandleType  * callHandle)
{	*callHandle=CURRENT_CALL_HANDLE;	}

void setCURRENT_CHAN_HANDLE(mciChanHandleType chanHandle)
{	CURRENT_CHAN_HANDLE=chanHandle;		}
void getCURRENT_CHAN_HANDLE(mciChanHandleType  * ChanHandle)
{	*ChanHandle=CURRENT_CHAN_HANDLE;	}

/*******************************************************/
void setCONFERENCES_HANDLE(HWND hWnd)
{	CONFERENCES_HANDLE=hWnd;		}
void getCONFERENCES_HANDLE(HWND  * hWnd)
{	*hWnd=CONFERENCES_HANDLE;	}


void setCONF_DETAIL_HANDLE(HWND hWnd)
{	CONF_DETAIL_HANDLE=hWnd;		}
void getCONF_DETAIL_HANDLE(HWND  * hWnd)
{	*hWnd=CONF_DETAIL_HANDLE;	}

void setCALL_DETAIL_HANDLE(HWND hWnd)
{	CALL_DETAIL_HANDLE=hWnd;		}
void getCALL_DETAIL_HANDLE(HWND  * hWnd)
{	*hWnd=CALL_DETAIL_HANDLE;	}

void setCHAN_CONTROL_HANDLE(HWND hWnd)
{	CHAN_CONTROL_HANDLE=hWnd;		}
void getCHAN_CONTROL_HANDLE(HWND  * hWnd)
{	*hWnd=CHAN_CONTROL_HANDLE;	}

//
void setGLOBALHWND(HWND hWnd)
{ GLOBALHWND=hWnd; }
void getGLOBALHWND(HWND * hWnd)
{ *hWnd=GLOBALHWND; }

void setCURRENT_DIALOG(int current_dialog)
{	CURRENT_DIALOG=current_dialog;	}
void getCURRENT_DIALOG(int * current_dialog)
{	*current_dialog=CURRENT_DIALOG;	}
void setCURRENT_HANDLE(int current_handle)
{	CURRENT_HANDLE=current_handle;	}
void getCURRENT_HANDLE(int * current_handle)
{;	*current_handle=CURRENT_HANDLE;	}


#ifdef __cplusplus
}
#endif

