/*
*********************************************************************************
*                                                                               *
* NOTICE:                                                                       *
* This document contains information that is confidential and proprietary to    *
* RADVision LTD.. No part of this publication may be reproduced in any form     *
* whatsoever without written prior approval by RADVision LTD..                  *
*                                                                               * 
* RADVision LTD. reserves the right to revise this publication and make changes *
* without obligation to notify any person of such revisions or changes.         *    
* Copyright RADVision 1996.                                                     *
* Last Revision: Jan. 2000                                                      *
*********************************************************************************
*/


/**********************************************************
		   PUBLIC  DECLARATIONS
*=========================================================
* TITLE: mcchannels control.c
*---------------------------------------------------------
* PROJECT: MC CONFIGURATION FOR PC
*---------------------------------------------------------
* $Workfile$
*---------------------------------------------------------
* $Author$ YONATAN BECKER
*---------------------------------------------------------
* $Date$ 29/9/99
*---------------------------------------------------------
* $Revision$
**********************************************************/

/********************************************************/
/*                     INTERFACE DECLARATIONS           */
/********************************************************/

#include "stdio.h"
#include "windowsx.h"
#include "windows.h"
#include "commctrl.h"
#include "resource.h"

#include <cm.h>

#include "resource.h"

#include "rvcommon.h"
#include "mci_types.h"
#include "mci_report.h"
#include "mci_general.h"
#include "mci_call_caps.h"

#include "gkadd.h"
#include "gkrgi.h"
#include "gkcci.h"

#include "mci_chan.h"
#include "mci_call.h"
#include "mci_conf.h"
#include "mci_mc.h"

#include "gkmc.h"
#include "mcgki.h"
#include "mcconfig.h"
#include "mcmain.h"

#include "mccall_details.h"
#include "mcchannels_control.h"
#include "mcrefresh.h"
#include "li.h"

static mciChanHandleType hChan;

BOOL videoChannel(mciMediaProtocolType Protocol)
{
	if((Protocol==H261)||(Protocol==H262)||(Protocol==H263)||(Protocol==videoNonStatndard)) return TRUE;
	else return FALSE;
}

void displayForwardParms(HWND hWnd)
{
	char str[100],tmpStr[100];
	char * p;
	long success;
	mciTransportType tmpAddress;
	mciMediaType Media=0;
	mciMediaProtocolType Protocol=0;
	int CIF=0,QCIF=0,serialNumber=0;
	memset (&(tmpAddress), 0, sizeof (mciTransportType));

/*Forward media type*/
	mciChanGetPrm(hChan,mciChanPrmMediaType,mciChanForward,(void *)&Media);
	if(mciChanMediaName(Media,&p)==MCI_RV_OK)
		success=SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,WM_SETTEXT,0,(LPARAM)p);
	else
		SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,WM_SETTEXT,0,(LPARAM)"unavailable");
	success=SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,EM_SETREADONLY,TRUE,0);
	if(Media!=mciMediaData)
	{
	/*Forward Remote Ctrl Address*/
		mciChanGetPrm(hChan,mciChanPrmRemoteMediaCtrlAddr,mciChanForward,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		SendDlgItemMessage (hWnd,IDC_FORWARD_REMOTE_CTRL_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_FORWARD_REMOTE_CTRL_ADDRESS,EM_SETREADONLY,FALSE,0);

	/*Forward Local Ctrl Address*/
		mciChanGetPrm(hChan,mciChanPrmLocalMediaCtrlAddr,mciChanForward,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		SendDlgItemMessage(hWnd,IDC_FORWARD_LOCAL_CTRL_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_FORWARD_LOCAL_CTRL_ADDRESS,EM_SETREADONLY,FALSE,0);

	}
	else //if media is data the ctrl forward address are not displayed
	{
		SendDlgItemMessage(hWnd,IDC_FORWARD_REMOTE_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_FORWARD_LOCAL_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
	}

/*Forward Media Address*/
		mciChanGetPrm(hChan,mciChanPrmMediaAddr,mciChanForward,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		success=SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA_ADDRESS,EM_SETREADONLY,FALSE,0);

/*Forward bit rate*/
	mciChanGetPrm(hChan,mciChanPrmBitRate,mciChanForward,(void *)tmpStr);
	sprintf(str,"%u",*(UINT32*)tmpStr);
	SendDlgItemMessage(hWnd,IDC_FORWARD_BIT_RATE,WM_SETTEXT,0,(LPARAM)str);
	if((Media!=mciMediaData)&&(Media!=mciMediaVideoData))
		SendDlgItemMessage(hWnd,IDC_FORWARD_BIT_RATE,EM_SETREADONLY,TRUE,0);
	else
		SendDlgItemMessage(hWnd,IDC_FORWARD_BIT_RATE,EM_SETREADONLY,FALSE,0);




/*Forward protocol type*/
	mciChanGetPrm(hChan,mciChanPrmProtocolType,mciChanForward,(void *)&Protocol);
	if(mciChanProtocolName(Protocol,&p)==MCI_RV_OK)
		SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,WM_SETTEXT,0,(LPARAM)p);
	else
		SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,WM_SETTEXT,0,(LPARAM)"unavailable");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,EM_SETREADONLY,TRUE,0);
	if(videoChannel(Protocol)==FALSE) 
	{
		SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,EM_SETREADONLY,TRUE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,EM_SETREADONLY,FALSE,0);
		SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,EM_SETREADONLY,FALSE,0);
	}

/*Forward CIF*/
	mciChanGetPrm(hChan,mciChanPrmCIF,mciChanForward,(void *)&CIF);
	if(CIF!=-1)
	{
		sprintf(str,"%d",CIF);
		SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,EM_SETREADONLY,FALSE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,WM_SETTEXT,0,(LPARAM)" ");
	    SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,EM_SETREADONLY,TRUE,0);
	}

/*Forward QCIF*/
	mciChanGetPrm(hChan,mciChanPrmQCIF,mciChanForward,(void *)&QCIF);
	if(QCIF!=-1)
	{
		sprintf(str,"%d",QCIF);
		SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,EM_SETREADONLY,FALSE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,WM_SETTEXT,0,(LPARAM)" ");
	    SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,EM_SETREADONLY,TRUE,0);
	}

/*Forward serial number*/
	mciChanGetPrm(hChan,mciChanPrmSideChanNumber,mciChanForward,(void *)&serialNumber);
	if(serialNumber!=-1)
	{
		sprintf(str,"%d",serialNumber);
		SendDlgItemMessage(hWnd,IDC_FORWARD_CHANNEL_NUMBER,WM_SETTEXT,0,(LPARAM)str);
	}
	else
		SendDlgItemMessage(hWnd,IDC_FORWARD_CHANNEL_NUMBER,WM_SETTEXT,0,(LPARAM)" ");
	SendDlgItemMessage(hWnd,IDC_FORWARD_CHANNEL_NUMBER,EM_SETREADONLY,TRUE,0);
}

void displayRevereseParms(HWND hWnd)
{
	char str[100],tmpStr[100];
	char * p;
	mciTransportType tmpAddress;
	mciMediaType Media=0;
	mciMediaProtocolType Protocol=0;
	int CIF=0,QCIF=0,serialNumber=0;
	memset (&(tmpAddress), 0, sizeof (mciTransportType));

/*Reverse media type*/
	mciChanGetPrm(hChan,mciChanPrmMediaType,mciChanReverse,(void *)&Media);
	if(mciChanMediaName(Media,&p)==MCI_RV_OK)
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,WM_SETTEXT,0,(LPARAM)p);
	else
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,WM_SETTEXT,0,(LPARAM)"unavailable");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,EM_SETREADONLY,TRUE,0);
	if(Media!=mciMediaData)
	{
	/*Reverse Remote Ctrl Address*/
		mciChanGetPrm(hChan,mciChanPrmRemoteMediaCtrlAddr,mciChanReverse,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		SendDlgItemMessage (hWnd,IDC_REVERSE_REMOTE_CTRL_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_REVERSE_REMOTE_CTRL_ADDRESS,EM_SETREADONLY,FALSE,0);

	/*Reverse Local Ctrl Address*/
		mciChanGetPrm(hChan,mciChanPrmLocalMediaCtrlAddr,mciChanReverse,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		SendDlgItemMessage(hWnd,IDC_REVERSE_LOCAL_CTRL_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_REVERSE_LOCAL_CTRL_ADDRESS,EM_SETREADONLY,FALSE,0);

	/*Reverse Media Address*/
		mciChanGetPrm(hChan,mciChanPrmMediaAddr,mciChanReverse,(void *)&tmpAddress);
		liIpToString(tmpAddress.ip,tmpStr);
		sprintf(str,"%s:%d",tmpStr,tmpAddress.port);
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA_ADDRESS,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA_ADDRESS,EM_SETREADONLY,FALSE,0);
	}
	else //if media is data the reverse address are not displayed
	{
		SendDlgItemMessage(hWnd,IDC_REVERSE_REMOTE_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_LOCAL_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA_ADDRESS,EM_SETREADONLY,TRUE,0);
	}


/*Reverse bit rate*/
	mciChanGetPrm(hChan,mciChanPrmBitRate,mciChanReverse,(void *)tmpStr);
	sprintf(str,"%u",*(UINT32*)tmpStr);
	SendDlgItemMessage(hWnd,IDC_REVERSE_BIT_RATE,WM_SETTEXT,0,(LPARAM)str);
	if((Media!=mciMediaData)&&(Media!=mciMediaVideoData))
		SendDlgItemMessage(hWnd,IDC_REVERSE_BIT_RATE,EM_SETREADONLY,TRUE,0);
	else
		SendDlgItemMessage(hWnd,IDC_REVERSE_BIT_RATE,EM_SETREADONLY,TRUE,0);


/*Reverse protocol type*/
	mciChanGetPrm(hChan,mciChanPrmProtocolType,mciChanReverse,(void *)&Protocol);
	if(mciChanProtocolName(Protocol,&p)==MCI_RV_OK)
		SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,WM_SETTEXT,0,(LPARAM)p);
	else
		SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,WM_SETTEXT,0,(LPARAM)"unavailable");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,EM_SETREADONLY,TRUE,0);
	if(videoChannel(Protocol)==FALSE)
	{
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,EM_SETREADONLY,TRUE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,EM_SETREADONLY,FALSE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,EM_SETREADONLY,FALSE,0);
	}

/*Reverse CIF*/
	mciChanGetPrm(hChan,mciChanPrmCIF,mciChanReverse,(void *)&CIF);
	if(CIF!=-1)
	{
		sprintf(str,"%d",CIF);
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,EM_SETREADONLY,FALSE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,WM_SETTEXT,0,(LPARAM)"");
	    SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,EM_SETREADONLY,TRUE,0);
	}

/*Reverse QCIF*/

	mciChanGetPrm(hChan,mciChanPrmQCIF,mciChanReverse,(void *)&QCIF);
	if(QCIF!=-1)
	{
		sprintf(str,"%d",QCIF);
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,WM_SETTEXT,0,(LPARAM)str);
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,EM_SETREADONLY,FALSE,0);
	}
	else
	{
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,WM_SETTEXT,0,(LPARAM)" ");
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,EM_SETREADONLY,TRUE,0);
	}

/*Reverse serial number*/
	mciChanGetPrm(hChan,mciChanPrmSideChanNumber,mciChanReverse,(void *)&serialNumber);
	if(serialNumber!=-1)
	{
		sprintf(str,"%d",serialNumber);
		SendDlgItemMessage(hWnd,IDC_REVERSE_CHANNEL_NUMBER,WM_SETTEXT,0,(LPARAM)str);
	}
	else
		SendDlgItemMessage(hWnd,IDC_REVERSE_CHANNEL_NUMBER,WM_SETTEXT,0,(LPARAM)" ");
	SendDlgItemMessage(hWnd,IDC_REVERSE_CHANNEL_NUMBER,EM_SETREADONLY,TRUE,0);
}

/*init the combo boxes*/

void initForwardMediaCB(HWND hWnd)
{
/*	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"nonStandard");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"audioData");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"videoData");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"data");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"nullData");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"encryptionData");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"h235Control");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"h235Media");
	SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,CB_ADDSTRING,0,(LPARAM)"undefined");
*/}

void initForwardProtocolCB(HWND hWnd)
{
/*	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"audioNonStandard");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Alaw64k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Alaw56k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Ulaw64k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Ulaw56k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_64k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_56k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_48k");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g7231");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g728");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729AnnexA");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729wAnnexB");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729AnnexAwAnnexB");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g7231AnnexCCapability");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmFullRate");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmHalfRate");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmEnhancedFullRate");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"videoNonStatndard");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H261");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H262");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H263");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dataNonStandard");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t120");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dsm_cc");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"userData");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t84");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dlpid");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"h222DataPartitioning");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t30fax");
	SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t140");
*/}

void initReverseMediaCB(HWND hWnd)
{
/*	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"nonStandard");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"audioData");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"videoData");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"data");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"nullData");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"encryptionData");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"h235Control");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"h235Media");
	SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,CB_ADDSTRING,0,(LPARAM)"undefined");
*/}

void initReverseProtocolCB(HWND hWnd)
{
/*	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"audioNonStandard");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Alaw64k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Alaw56k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Ulaw64k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g711Ulaw56k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_64k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_56k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g722_48k");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g7231");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g728");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729AnnexA");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729wAnnexB");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g729AnnexAwAnnexB");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"g7231AnnexCCapability");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmFullRate");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmHalfRate");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"gsmEnhancedFullRate");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"videoNonStatndard");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H261");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H262");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"H263");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dataNonStandard");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t120");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dsm_cc");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"userData");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t84");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"dlpid");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"h222DataPartitioning");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t30fax");
	SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,CB_ADDSTRING,0,(LPARAM)"t140");
*/}



void initChannelsDetailsDialog(HWND hWnd)
{
	char str[100];
	char * p;
	BOOL isDuplex;
	mciChanHandleType coupledHandle=0,replacementForHandle=0,sameSessionHandle=0;
	mciChanStateType state=0;
	mciDirectionType direction=0;
	long success;

/*channel handle*/
	sprintf(str,"%x",hChan);
	SendDlgItemMessage(hWnd,IDC_CHANNEL_HANDLE,WM_SETTEXT,0,(LPARAM)str);
	SendDlgItemMessage(hWnd,IDC_CHANNEL_HANDLE,EM_SETREADONLY,TRUE,0);

/*coupled handle*/
	mciChanGetPrm(hChan,mciChanPrmCoupledHandle,mciChanGeneral,(void *)&coupledHandle);
	sprintf(str,"%x",coupledHandle);
	SendDlgItemMessage(hWnd,IDC_COUPLED_HANDLE,WM_SETTEXT,0,(LPARAM)str);
	SendDlgItemMessage(hWnd,IDC_COUPLED_HANDLE,EM_SETREADONLY,FALSE,0);

/*replacement handle*/
	mciChanGetPrm(hChan,mciChanPrmReplacementFor,mciChanGeneral,(void *)&replacementForHandle);
	sprintf(str,"%x",replacementForHandle);
	SendDlgItemMessage(hWnd,IDC_REPLACEMENT_HANDLE,WM_SETTEXT,0,(LPARAM)str);
	SendDlgItemMessage(hWnd,IDC_REPLACEMENT_HANDLE,EM_SETREADONLY,FALSE,0);

/*same session*/
	mciChanGetPrm(hChan,mciChanPrmSameSession,mciChanGeneral,(void *)&sameSessionHandle);
	sprintf(str,"%x",sameSessionHandle);
	SendDlgItemMessage(hWnd,IDC_SAME_SESSION,WM_SETTEXT,0,(LPARAM)str);
	SendDlgItemMessage(hWnd,IDC_SAME_SESSION,EM_SETREADONLY,FALSE,0);

/*direction*/
	mciChanGetPrm(hChan,mciChanPrmDirection,mciChanGeneral,(void *)&direction);
	if(mciChanDirectionName(direction,&p)==MCI_RV_OK)
		success=SendDlgItemMessage(hWnd,IDC_DIRECTION,WM_SETTEXT,0,(LPARAM)p);
	else
		success=SendDlgItemMessage(hWnd,IDC_DIRECTION,WM_SETTEXT,0,(LPARAM)"unavailable");
	success=SendDlgItemMessage(hWnd,IDC_DIRECTION,EM_SETREADONLY,TRUE,0);

/*state*/
	mciChanGetState(hChan,&state);
	if(mciChanStateName(state,&p)==MCI_RV_OK)
		SendDlgItemMessage(hWnd,IDC_STATE,WM_SETTEXT,0,(LPARAM)p);
	else
		SendDlgItemMessage(hWnd,IDC_STATE,WM_SETTEXT,0,(LPARAM)"unavailable");
	SendDlgItemMessage(hWnd,IDC_STATE,EM_SETREADONLY,TRUE,0);

	
	displayForwardParms(hWnd);
/*init the combo boxes*/
	initForwardMediaCB(hWnd);
	initForwardProtocolCB(hWnd);

	mciChanGetPrm(hChan,mciChanPrmIsDuplex,mciChanGeneral,(void *)&isDuplex);
	if(isDuplex){
		SendDlgItemMessage(hWnd,IDC_DESCRIPTION,WM_SETTEXT,0,(LPARAM)"bi-directional");
		displayRevereseParms(hWnd);
		initReverseMediaCB(hWnd);
		initReverseProtocolCB(hWnd);
	}
	else{
		SendDlgItemMessage(hWnd,IDC_DESCRIPTION,WM_SETTEXT,0,(LPARAM)"uni-directional");

		SendDlgItemMessage(hWnd,IDC_REVERSE_REMOTE_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_LOCAL_CTRL_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA_ADDRESS,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_BIT_RATE,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,EM_SETREADONLY,TRUE,0);
		SendDlgItemMessage(hWnd,IDC_REVERSE_CHANNEL_NUMBER,EM_SETREADONLY,TRUE,0);		
	}
	SendDlgItemMessage(hWnd,IDC_DESCRIPTION,EM_SETREADONLY,TRUE,0);

}

/************************************************************************/
/*reading parameters from the dialog*/
void stringToIPString(char * str,char * IPStr)
{
	int i=0;
	while(str[i]!=':')
	{
		IPStr[i]=str[i];
		i++;
	}
	IPStr[i]='\0';
}

void stringToPort(char * str,unsigned short * port)
{
	char portStr[10];
	int i=0,j=0;
	while(str[i]!=':')
		i++;
	i++;
	while(str[i])
	{
		portStr[j]=str[i];
		i++;
		j++;
	}
	portStr[j]='\0';
	*port=atoi(portStr);
}


void readForwardParams(HWND hWnd)
{
	char str[100],IPStr[100];
	long success;
	mciTransportType tmpAddress;
	UINT32 bitRate;
	mciMediaType Media=0;
	mciMediaProtocolType Protocol=0;
	MciRV retVal;
	int CIF=0,QCIF=0;

//if media is data the ctrl forward address are not set
	mciChanGetPrm(hChan,mciChanPrmMediaType,mciChanForward,(void *)&Media);
	if(Media!=mciMediaData)
	{
	/*Forward Remote Ctrl Address*/
		success=SendDlgItemMessage(hWnd,IDC_FORWARD_REMOTE_CTRL_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			stringToIPString(str,IPStr);
			memset (&(tmpAddress), 0, sizeof (mciTransportType));
			stringToPort(str,&tmpAddress.port);
			tmpAddress.ip=liConvertIp(IPStr);
			retVal=mciChanSetPrm(hChan,mciChanPrmRemoteMediaCtrlAddr,mciChanForward,(void *)&tmpAddress);
		}

	/*Forward Local Ctrl Address*/
		success=SendDlgItemMessage(hWnd,IDC_FORWARD_LOCAL_CTRL_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			stringToIPString(str,IPStr);
			memset (&(tmpAddress), 0, sizeof (mciTransportType));
			stringToPort(str,&tmpAddress.port);
			tmpAddress.ip=liConvertIp(IPStr);
			mciChanSetPrm(hChan,mciChanPrmLocalMediaCtrlAddr,mciChanForward,(void *)&tmpAddress);
		}
	}
/*Forward Media Address*/
	success=SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		stringToIPString(str,IPStr);
		memset (&(tmpAddress), 0, sizeof (mciTransportType));
		stringToPort(str,&tmpAddress.port);
		tmpAddress.ip=liConvertIp(IPStr);
		mciChanSetPrm(hChan,mciChanPrmMediaAddr,mciChanForward,(void *)&tmpAddress);
	}

/*Forward bit rate*/
	if((Media==mciMediaData)||(Media==mciMediaVideoData))
	{
		success=SendDlgItemMessage(hWnd,IDC_FORWARD_BIT_RATE,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			bitRate=atoi(str);
			mciChanSetPrm(hChan,mciChanPrmBitRate,mciChanForward,(void *)&bitRate);
		}
	}

/*Forward CIF and QCIF are set when if they were available if its a video channel*/
	mciChanGetPrm(hChan,mciChanPrmProtocolType,mciChanForward,(void *)&Protocol);
	if(videoChannel(Protocol)==TRUE) 
	{
		mciChanGetPrm(hChan,mciChanPrmCIF,mciChanForward,(void *)&CIF);
		if(CIF!=-1)
		{
			success=SendDlgItemMessage(hWnd,IDC_FORWARD_CIF,WM_GETTEXT,sizeof(str),(LPARAM)str);
			if(success)
			{
				CIF=atoi(str);
				retVal=mciChanSetPrm(hChan,mciChanPrmCIF,mciChanForward,(void *)&CIF);
			}
		}
	/*Forward QCIF*/
		mciChanGetPrm(hChan,mciChanPrmQCIF,mciChanForward,(void *)&QCIF);
		if(QCIF!=-1)
		{
			success=SendDlgItemMessage(hWnd,IDC_FORWARD_QCIF,WM_GETTEXT,sizeof(str),(LPARAM)str);
			if(success)
			{
				QCIF=atoi(str);
				retVal=mciChanSetPrm(hChan,mciChanPrmQCIF,mciChanForward,(void *)&QCIF);
			}
		}
	}
/*Forward media type*/
	success=SendDlgItemMessage(hWnd,IDC_FORWARD_MEDIA,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		mciChanMediaByName(str,&Media); 
		mciChanSetPrm(hChan,mciChanPrmMediaType,mciChanForward,(void *)&Media);
	}

/*Forward protocol type*/
	success=SendDlgItemMessage(hWnd,IDC_FORWARD_PROTOCOL,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		mciChanProtocolByName(str,&Protocol); 
		mciChanSetPrm(hChan,mciChanPrmProtocolType,mciChanForward,(void *)&Protocol);
	}
}

void readReverseParams(HWND hWnd)
{
	char str[100],IPStr[100];
	long success;
	mciTransportType tmpAddress;
	UINT32 bitRate;
	mciMediaType Media;
	mciMediaProtocolType Protocol=0;
	MciRV retVal;
	int CIF=0,QCIF=0;

/*Reverse Remote Ctrl Address*/
//if media is data the ctrl forward address are not set
	mciChanGetPrm(hChan,mciChanPrmMediaType,mciChanReverse,(void *)&Media);
	if(Media!=mciMediaData)
	{
		success=SendDlgItemMessage(hWnd,IDC_REVERSE_REMOTE_CTRL_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			stringToIPString(str,IPStr);
			memset (&(tmpAddress), 0, sizeof (mciTransportType));
			stringToPort(str,&tmpAddress.port);
			tmpAddress.ip=liConvertIp(IPStr);
			mciChanSetPrm(hChan,mciChanPrmRemoteMediaCtrlAddr,mciChanReverse,(void *)&tmpAddress);
		}
		
		/*Reverse Local Ctrl Address*/
		success=SendDlgItemMessage(hWnd,IDC_REVERSE_LOCAL_CTRL_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			stringToIPString(str,IPStr);
			memset (&(tmpAddress), 0, sizeof (mciTransportType));
			stringToPort(str,&tmpAddress.port);
			tmpAddress.ip=liConvertIp(IPStr);
			mciChanSetPrm(hChan,mciChanPrmLocalMediaCtrlAddr,mciChanReverse,(void *)&tmpAddress);
		}
		
		/*Reverse Media Address*/
		success=SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA_ADDRESS,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			stringToIPString(str,IPStr);
			memset (&(tmpAddress), 0, sizeof (mciTransportType));
			stringToPort(str,&tmpAddress.port);
			tmpAddress.ip=liConvertIp(IPStr);
			mciChanSetPrm(hChan,mciChanPrmMediaAddr,mciChanReverse,(void *)&tmpAddress);
		}
	}

/*Reverse bit rate*/
	if((Media==mciMediaData)||(Media==mciMediaVideoData))
	{
		success=SendDlgItemMessage(hWnd,IDC_REVERSE_BIT_RATE,WM_GETTEXT,sizeof(str),(LPARAM)str);
		if(success)
		{
			bitRate=atoi(str);
			mciChanSetPrm(hChan,mciChanPrmBitRate,mciChanReverse,(void *)&bitRate);
		}
	}

/*Reverse CIF and QCIF are set when if they were available if its a video channel*/
	mciChanGetPrm(hChan,mciChanPrmProtocolType,mciChanReverse,(void *)&Protocol);
	if(videoChannel(Protocol)==TRUE) 
	{
		mciChanGetPrm(hChan,mciChanPrmCIF,mciChanReverse,(void *)&CIF);
		if(CIF!=-1)
		{
			success=SendDlgItemMessage(hWnd,IDC_REVERSE_CIF,WM_GETTEXT,sizeof(str),(LPARAM)str);
			if(success)
			{
				CIF=atoi(str);
				retVal=mciChanSetPrm(hChan,mciChanPrmCIF,mciChanReverse,(void *)&CIF);
			}
		}
	/*Reverse QCIF*/
		mciChanGetPrm(hChan,mciChanPrmQCIF,mciChanReverse,(void *)&QCIF);
		if(QCIF!=-1)
		{
			success=SendDlgItemMessage(hWnd,IDC_REVERSE_QCIF,WM_GETTEXT,sizeof(str),(LPARAM)str);
			if(success)
			{
				QCIF=atoi(str);
				retVal=mciChanSetPrm(hChan,mciChanPrmQCIF,mciChanReverse,(void *)&QCIF);
			}
		}
	}
/*Reverse media type*/
	success=SendDlgItemMessage(hWnd,IDC_REVERSE_MEDIA,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		mciChanMediaByName(str,&Media); 
		mciChanSetPrm(hChan,mciChanPrmMediaType,mciChanReverse,(void *)&Media);
	}

/*Reverse protocol type*/
	success=SendDlgItemMessage(hWnd,IDC_REVERSE_PROTOCOL,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		mciChanProtocolByName(str,&Protocol); 
		mciChanSetPrm(hChan,mciChanPrmProtocolType,mciChanReverse,(void *)&Protocol);
	}
}

void readGeneralParams(HWND hWnd)
{
	char str[100];
	long success;
	int tmp;
	mciChanHandleType coupledHandle=0,replacementForHandle=0,sameSessionHandle=0;
	MciRV retVal;
/*coupled handle*/
	success=SendDlgItemMessage(hWnd,IDC_COUPLED_HANDLE,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		sscanf(str,"%x",&tmp);
		coupledHandle=(mciChanHandleType)tmp;
		retVal=mciChanSetPrm(hChan,mciChanPrmCoupledHandle,mciChanGeneral,(void *)&coupledHandle);
	}
/*replacement handle*/
	success=SendDlgItemMessage(hWnd,IDC_REPLACEMENT_HANDLE,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		sscanf(str,"%x",&tmp);
		replacementForHandle=(mciChanHandleType)tmp;
		retVal=mciChanSetPrm(hChan,mciChanPrmReplacementFor,mciChanGeneral,(void *)&replacementForHandle);
	}

/*same session*/
	success=SendDlgItemMessage(hWnd,IDC_SAME_SESSION,WM_GETTEXT,sizeof(str),(LPARAM)str);
	if(success)
	{
		sscanf(str,"%x",&tmp);
		sameSessionHandle=(mciChanHandleType)tmp;
		retVal=mciChanSetPrm(hChan,mciChanPrmSameSession,mciChanGeneral,(void *)&sameSessionHandle);
	}

}

void readDialogParams(HWND hWnd)
{
	BOOL isDuplex;
	mciCallHandleType hChanParent=0;
	readGeneralParams(hWnd);
	readForwardParams(hWnd);
	mciChanGetPrm(hChan,mciChanPrmIsDuplex,mciChanGeneral,(void *)&isDuplex);
	if(isDuplex)
		readReverseParams(hWnd);
	mciChanGetCall(hChan,&hChanParent);
	RefreshCallDialog(hChanParent,VALID_HANDLE);
}

/****************************************************************************/
void refreshChannelControl(HWND hWnd)
{
	setCHAN_CONTROL_HANDLE(hWnd);
	setCURRENT_CHAN_HANDLE(hChan);
	initChannelControlButton(hWnd);
	initChannelsDetailsDialog(hWnd);
}

void initChannelControlButton(HWND hWnd)
{
	mciChanStateType state=0;
	char *stateName;
	HWND mchWnd;
	mciChanHandleType coupledChanHandle;

	mciChanGetState(hChan,&state);
//IDC_COUPLED_CHANNEL is enabled only if the coupled channel isn't closed
	mciChanGetPrm(hChan,mciChanPrmCoupledHandle,mciChanGeneral,(void *)&coupledChanHandle);
	if(coupledChanHandle==VACANT_HANDLE)
		Button_Enable(GetDlgItem(hWnd,IDC_COUPLED_CHANNEL),FALSE);
	else
		Button_Enable(GetDlgItem(hWnd,IDC_COUPLED_CHANNEL),TRUE);

	mciChanStateName(state,&stateName);
	switch(state) {
	case mciChanStateOffering:
		if(coupledChanHandle==VACANT_HANDLE)
		{
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),TRUE);
		}
		else
		{
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),FALSE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		}
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
    case mciChanStateWaiting:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),FALSE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
	case mciChanStateDuplicated:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),TRUE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),TRUE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
    case mciChanStateAckRecieved:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),TRUE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
    case mciChanStateAckDuplicated:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),TRUE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),TRUE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
	case mciChanStateDisconnected:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),TRUE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),TRUE);
		break;
	case mciChanStateIdle:
		getMcMainHwnd(&mchWnd);

		if(IsDlgButtonChecked(mchWnd,IDC_CHECK_CHANNEL)==1)
			EndChannelControlDialog(hWnd,0);
		else //manual mode
		{
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),TRUE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),FALSE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),FALSE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),TRUE);
			Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		}
		break;
	case mciChanStateConnected:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),FALSE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;
	case mciChanStateDialtone:
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DUPLICATE),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_RELAY),FALSE);
        Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_CLOSE),FALSE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DROP),TRUE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_REJECT),FALSE);
	    Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_DEFAULT),FALSE);
		Button_Enable(GetDlgItem(hWnd,IDC_BUTTON_APPROVE_DISCONNECT),FALSE);
		break;




	}

}

/****************************************************************************/

int	EndChannelControlDialog(HWND hWnd,int nResult)
{
	setCURRENT_CHAN_HANDLE(0);
	setCHAN_CONTROL_HANDLE(0);
	return EndDialog(hWnd,nResult);
}


BOOL CALLBACK channelControlWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	mciChanHandleType coupledChanHandle;
	mciCallHandleType coupledChanFatherHandle,hCall;
	HWND CALL_DETAILS_HWND;
	MciRV retVal;
	mciChanAppHandleType haChan=0;
	mciChanStateType state=0;
	mciChanReasonType stateMode=0;
	switch (message) 
	{
	case WM_INITDIALOG:
		{
		hChan=(mciChanHandleType)lParam;
		refreshChannelControl(hWnd);
		return TRUE;
		}
	case WM_REFRESH_DIALOG:
		if(lParam)
			hChan=(mciChanHandleType)lParam;
		refreshChannelControl(hWnd);
		return TRUE;
	
	case WM_CLOSE:
		EndChannelControlDialog(hWnd,0);
		//return mciChanPTPStateReply(hChan,mciChanPTPReplyDefault, mciChanReplyReasonUndefined);
		break;
		
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam,lParam)){
		case IDC_CHANNELS_CONTROL_OK:
			readDialogParams(hWnd);
			EndChannelControlDialog(hWnd,0);
			return TRUE;

		case IDC_BUTTON_RELAY:
			readDialogParams(hWnd);
			return mciChanPTPStateReply(hChan,mciChanPTPReplyRelay, mciChanReplyReasonUndefined);

  		case IDC_BUTTON_REJECT:
			readDialogParams(hWnd);
			return mciChanPTPStateReply(hChan,mciChanPTPReplyReject, mciChanReplyReasonUndefined);

		case IDC_BUTTON_DUPLICATE:
			readDialogParams(hWnd);
			retVal=mciChanPTPStateReply(hChan, mciChanPTPReplyDuplicate, mciChanReplyReasonUndefined);
			refreshChannelControl(hWnd);
			return retVal;

		case IDC_BUTTON_CLOSE:
			readDialogParams(hWnd);
			EndChannelControlDialog(hWnd,0);
		    retVal = mciChanClose(hChan);
			//refreshChannelControl(hWnd);
            return retVal;
		case IDC_BUTTON_DEFAULT:
			readDialogParams(hWnd);
			mciChanGetState(hChan,&state);
			mciChanGetPrm(hChan,mciChanPrmAppHandle,mciChanGeneral,(void *)&haChan);
			mciChanGetCall(hChan,&hCall);
			mciChanGetPrm(hChan,mciChanPrmStateReason,mciChanGeneral,(void *)&stateMode);
//			return mciChanPTPStateReply(hChan,mciChanPTPReplyDefault, mciChanReplyReasonUndefined);
			retVal=mciDefEvPTPChanStateHandler(haChan,hChan,hCall,state,stateMode);
			if(state==mciChanStateIdle)
				EndChannelControlDialog(hWnd,0);
			else
				refreshChannelControl(hWnd);
			return retVal;

		case IDC_BUTTON_APPROVE_DISCONNECT:
			readDialogParams(hWnd);
			return mciChanPTPStateReply(hChan,mciChanPTPReplyApproveDisconnect, mciChanReplyReasonUndefined);

   		case IDC_BUTTON_DROP:
			readDialogParams(hWnd);
			return mciChanDrop(hChan);

		case IDC_COUPLED_CHANNEL:
			mciChanGetPrm(hChan,mciChanPrmCoupledHandle,mciChanGeneral,(void *)&coupledChanHandle);
			if(mciChanGetCall(coupledChanHandle,&coupledChanFatherHandle)!=MCI_RV_OK)
			{
				MessageBox(0,"The Coupled Channel doesn't exist","Alarm",MB_OK|MB_ICONEXCLAMATION);
				return FALSE;
			}
			else
			{
			//refresh CALL_DETAILS and CHANNELS_CONTROL dialogs:
				SendMessage(hWnd,WM_REFRESH_DIALOG,0,(LPARAM)coupledChanHandle);
				getCALL_DETAIL_HANDLE(&CALL_DETAILS_HWND);
				if(CALL_DETAILS_HWND)
					SendMessage(CALL_DETAILS_HWND,WM_REFRESH_DIALOG,0,(LPARAM)coupledChanFatherHandle);	
			}
	
		default: 
			return FALSE;
		}
	default:
		return FALSE;

	}

 return TRUE;
}

