/*
*********************************************************************************
*                                                                               *
* NOTICE:                                                                       *
* This document contains information that is confidential and proprietary to    *
* RADVision LTD.. No part of this publication may be reproduced in any form     *
* whatsoever without written prior approval by RADVision LTD..                  *
*                                                                               * 
* RADVision LTD. reserves the right to revise this publication and make changes *
* without obligation to notify any person of such revisions or changes.         *    
* Copyright RADVision 1996.                                                     *
* Last Revision: Jan. 2000                                                      *
*********************************************************************************
*/

/* File : mcconfig.h */
#ifndef _MCCONFIG_
#define _MCCONFIG_

extern const char* cDefaultConfigFileName;

#define ALLOCATIONS_CONFIG_FILE     "mcmem.ini"
#define DEFAULT_MAX_CONF  60
#define DEFAULT_MAX_CALLS  120
#define DEFAULT_MAX_CHANS  240


#define CHANS_PER_CALLS (DEFAULT_MAX_CHANS % DEFAULT_MAX_CALLS == 0) ?  \
                         DEFAULT_MAX_CHANS / DEFAULT_MAX_CALLS : \
                         DEFAULT_MAX_CHANS / DEFAULT_MAX_CALLS + 1



#define DEFAULT_MC_PORT  1721


BOOL CALLBACK configWndProc(HWND hWnd, 
         				    UINT message, 
						    WPARAM wParam, 
						    LPARAM lParam);

//holds all configuration data from the first window.
typedef struct {
	UINT16   port;
    UINT16   maxConfs;
	UINT16   maxCalls;
	UINT16   maxChans;
} configInput;



BOOL mcGetConfiguration (IN const char* configFileName,
						 OUT configInput* configuration);
static BOOL loadConfigData(void);
static BOOL saveConfigurationData(void);
static BOOL loadGeneralData(FILE *fd);

void readGeneralValues(IN FILE* fd);
void readDialogValues();
void setDefaultValues();
              
MciRV CALLCONV mcOutputMsg (IN UINT32 logClass, IN const char* msg);



#endif /* _MCCONFIG_ */
