/*
*********************************************************************************
*                                                                               *
* NOTICE:                                                                       *
* This document contains information that is confidential and proprietary to    *
* RADVision LTD.. No part of this publication may be reproduced in any form     *
* whatsoever without written prior approval by RADVision LTD..                  *
*                                                                               * 
* RADVision LTD. reserves the right to revise this publication and make changes *
* without obligation to notify any person of such revisions or changes.         *    
* Copyright RADVision 1996.                                                     *
* Last Revision: Jan. 2000                                                      *
*********************************************************************************
*/


/**********************************************************
		   PUBLIC  DECLARATIONS
*=========================================================
* TITLE: mcpending.c
*---------------------------------------------------------
* PROJECT: MC CONFIGURATION FOR PC
*---------------------------------------------------------
* $Workfile$
*---------------------------------------------------------
* $Author$ YONATAN BECKER
*---------------------------------------------------------
* $Date$ 31/10/99
*---------------------------------------------------------
* $Revision$
**********************************************************/

/********************************************************/
/*                     INTERFACE DECLARATIONS           */
/********************************************************/

#ifdef WIN32
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#endif

#include <cm.h>

#include "resource.h"

#include "rvcommon.h"
#include "mci_types.h"
#include "mci_report.h"
#include "mci_general.h"
#include "mci_call_caps.h"

#include "gkadd.h"
#include "gkrgi.h"
#include "gkcci.h"

#include "mci_chan.h"
#include "mci_call.h"
#include "mci_conf.h"
#include "mci_mc.h"

#include "gkmc.h"
#include "mcgki.h"
#include "mcconfig.h"
#include "mcmain.h"

#include "configutl.h"

/*pending channels*/

/*checks if the call has pending channles*/
BOOL pendingChannelsInCall(mciCallHandleType hCall)
{
	mciChanHandleType hChan=0;
	mciChanStateType state=0;
	mciCallGetFirstChan(hCall,&hChan);
	while(hChan)
	{
		mciChanGetState(hChan,&state);
		if(state!=mciChanStateConnected)
			return TRUE;
		mciCallGetNextChan(hChan,&hChan);
	}
	return FALSE;
}

/*checks if the conf has pending channles*/
BOOL pendingChannelsInConf(mciConfHandleType hConf)
{
	mciCallHandleType hCall=0;
	mciConfGetFirstCall(hConf,&hCall);
	while(hCall)
	{
		if(pendingChannelsInCall(hCall))
			return TRUE;
		mciConfGetNextCall(hCall,&hCall);
	}
	return FALSE;
}


/***************************************************************************/
/*pending CE*/

BOOL pendingCE(mciConfHandleType hConf)
{
	mciCallHandleType hCall=0;
	mciCEStateType CEState=0; 
	mciConfGetFirstCall(hConf,&hCall);
	while(hCall)
	{
		mciCallGetPrm(hCall,mciCallPrmRemoteCEState,(void *)&CEState);
		if(CEState==mciCESttCapSetRecvd)
			return TRUE;
		mciCallGetPrm(hCall,mciCallPrmLocalCEState,(void *)&CEState);
		if(CEState==mciCESttCapSetReady)
			return TRUE;
		mciConfGetNextCall(hCall,&hCall);
	}
	return FALSE;
}

/***************************************************************************/
/*pending MSD*/

BOOL pendingMSD(mciConfHandleType hConf)
{
	mciCallHandleType hCall=0;
	mciMsdStateType MsdState=0;
	mciConfGetFirstCall(hConf,&hCall);
	while(hCall)
	{
		mciCallGetPrm(hCall,mciCallPrmMsdState,(void *)&MsdState);
		if((MsdState==mciMsdSttMsdRecvd)||(MsdState==mciMsdSttAckRecvd)||(MsdState == mciMsdSttMsdRelayed))
			return TRUE;
		mciConfGetNextCall(hCall,&hCall);
	}
	return FALSE;
}
