#ifdef __cplusplus
extern "C" {
#endif



/*
***********************************************************************************

NOTICE:
This document contains information that is proprietary to RADVision LTD..
No part of this publication may be reproduced in any form whatsoever without 
written prior approval by RADVision LTD..

RADVision LTD. reserves the right to revise this publication and make changes 
without obligation to notify any person of such revisions or changes.

***********************************************************************************
*/

/*
  cmchannel.h

  Ron S.
  15 Jan 1997.

  */

#ifndef _CHCHANNELH_
#define _CHCHANNELH_


int
cmcGetIpAddress(
		/* get ip parameters from value tree */
		IN  HPVT hVal, 
		IN  int ipAddressId,
		OUT UINT32* ip,
		OUT UINT32* port
		);

int
cmcSetIpAddress(
		/* Create IP parameters to TransportAddress value tree. */
		IN  HPVT hVal,
		IN  int transportAddressId,
		IN  BOOL isUnicast,
		IN  UINT32 ip,
		IN  UINT32 port
		);

int
cmcSendMsg(
	   HPdlSProtocol hsProtocol, 
	   int nodeId);

int
cmcCallDataTypeHandleCallback(
			      /* Call the data type handle callback */
			      IN  cmElem* app,
			      IN  HCHAN hsChan, /* channel protocol */
			      IN  int dataType, /* channel data type node id */
			      IN  confDataType type
			      );

int
cmcCallChannelParametersCallback(
				 /* Call the channel parameter callback */
				 IN  cmElem* app,
				 IN  HCHAN hsChan, /* channel protocol */
				 IN  int dataType, /* channel data type node id */
				 OUT confDataType* type
				 );

int
newChannelMsg(
	      IN	HPdlAProtocol		haProtocol,
	      IN	HPdlSProtocol		hsProtocol,
	      IN	int			message
	      );

int
newChannelOutMsg(
		 IN	HPdlAProtocol		haProtocol,
		 IN	HPdlSProtocol		hsProtocol,
		 IN	int			message
		 );

int
newChannelProtocol(
		   IN	HPdlAProtocol		haProtocolParent,
		   IN	HPdlSProtocol		hsProtocol,
		   OUT	HPdlAProtocol*		lphaProtocol,
		   IN	char*			protocolName,
		   OUT	newProtocolEH*		newProtocol,
		   OUT	newMessageEH*		newMessage,
                   OUT	BOOL*   		selfDestructing
		   );

#endif
#ifdef __cplusplus
}              
#endif



