#ifdef __cplusplus
extern "C" {
#endif



/*

NOTICE:
This document contains information that is proprietary to RADVision LTD..
No part of this publication may be reproduced in any form whatsoever without 
written prior approval by RADVision LTD..

RADVision LTD. reserves the right to revise this publication and make changes 
without obligation to notify any person of such revisions or changes.

*/ 

#ifndef CMHOOK_H
#define CMHOOK_H


typedef BOOL   
    (CALLCONV *cmHookListenT)(/*Before listen*/
		IN      HPROTCONN           hConn,
		IN      int                 addr
		);


typedef int 
    (CALLCONV *cmHookListeningT)(/*After listen*/
                IN      HPROTCONN           hConn,
		IN      int                 addr,
		IN      BOOL                error
                );

typedef int 
    (CALLCONV*cmHookConnectingT)(/*Before connect*/
                IN      HPROTCONN           hConn,
                IN      int                 addr
		);
    
typedef int 
    (CALLCONV*cmHookInConnT)(/*Incomming connect*/
                IN      HPROTCONN           hConn,
                IN      int                 addrFrom,
                IN      int                 addrTo
		);   
typedef int 
    (CALLCONV*cmHookOutConnT)(/*Outgoing connect*/
                IN      HPROTCONN           hConn,
		IN      int                 addrFrom,
                IN      int                 addrTo,
                IN      BOOL                error
                );   
typedef BOOL
    (CALLCONV*cmHookSendT)(
                IN      HPROTCONN           hConn,
		IN      int                 nodeId,
		IN      BOOL                error
		);   
typedef BOOL 
    (CALLCONV*cmHookRecvT)(
                IN      HPROTCONN           hConn,
		IN      int                 nodeId,
		IN      BOOL                error
	        );   

typedef BOOL
    (CALLCONV*cmHookSendToT)(
                IN      HPROTCONN           hConn,
		IN      int                 nodeId,
                IN      int                 addrTo,
		IN      BOOL                error
		);   
typedef BOOL 
    (CALLCONV*cmHookRecvFromT)(
                IN      HPROTCONN           hConn,
		IN      int                 nodeId,
                IN      int                 addrFrom,
                IN      BOOL                multicast,
		IN      BOOL                error
	        );   

typedef void
    (CALLCONV*cmHookCloseT)(
                IN      HPROTCONN           hConn
		);   


typedef  struct 
{
   cmHookListenT      hookListen;
   cmHookListeningT   hookListening;
   cmHookConnectingT  hookConnecting;
   cmHookInConnT      hookInConn;    
   cmHookOutConnT     hookOutConn;
   cmHookSendT        hookSend;
   cmHookRecvT        hookRecv;
   cmHookSendToT      hookSendTo;
   cmHookRecvFromT    hookRecvFrom;
   cmHookCloseT       hookClose;
} SCMPROTOCOLEVENT,*CMPROTOCOLEVENT;

RVAPI
int CALLCONV cmSetProtocolEventHandler(
		IN	HAPP		hApp,
		IN 	CMPROTOCOLEVENT	cmProtocolEvent,
		IN 	int		size);

RVAPI
int CALLCONV cmProtocolSendMessage(
		IN	HAPP		hApp,
                IN	HPROTCONN       hConn,
		IN 	int             msg);

RVAPI
int CALLCONV cmProtocolSendMessageTo(
		IN	HAPP		hApp,
                IN	HPROTCONN       hConn,
		IN 	int             msg,
                IN 	int             addr);

typedef enum {
    cmProtocolUnknown,
    cmProtocolRAS,
    cmProtocolQ931,
    cmProtocolH245
} cmProtocol;


/* Creates new message value tree*/
RVAPI int /* New message nodeId*/
CALLCONV cmProtocolCreateMessage(
                IN      HAPP                    hApp,
                IN      cmProtocol              protocol);

RVAPI/* returns protocol of the message tree*/
cmProtocol CALLCONV cmProtocolGetProtocol(
                IN      HAPP                    hApp,
                IN      int                     msg);/* message nodeId*/


RVAPI
char* CALLCONV cmProtocolGetProtocolName(
                IN      cmProtocol              protocol);

#endif
#ifdef __cplusplus
}              
#endif



