#ifdef __cplusplus
extern "C" {
#endif
/*
***********************************************************************************

NOTICE:
This document contains information that is proprietary to RADVision LTD..
No part of this publication may be reproduced in any form whatsoever without 
written prior approval by RADVision LTD..

RADVision LTD. reserves the right to revise this publication and make changes 
without obligation to notify any person of such revisions or changes.

***********************************************************************************
*/



#ifndef _FAST_START_H
#define _FAST_START_H

#ifndef CM_H
#error faststart.h included improperly. Use #include <cm.h> instead.
#else

#define MAX_ALTERNATIVE_CHANNEL 10
#define MAX_FS_CHANNELS 3 /* restricted by well known sessionId 1 for audio,2 for video*/

typedef struct
{
  cmTransportAddress rtp; /* not used for outgoing (transmit) channels */
  cmTransportAddress rtcp;
  int dataTypeHandle;
  char *channelName;
  int index;
}cmFastStartChannel;





typedef struct
{
  cmFastStartChannel channels[MAX_ALTERNATIVE_CHANNEL];
  int altChannelNumber;
}cmAlternativeChannels; /* alternative proposes channel list.
                      Only one channel must be chose by called endpoint.*/
  

typedef struct
{
  cmCapDataType type;
  cmAlternativeChannels transmit;
  cmAlternativeChannels receive;
}cmPartnerChannels;
typedef struct

{
  cmPartnerChannels partnerChannels[MAX_FS_CHANNELS];
  int partnerChannelsNum;

}cmFastStartMessage;


RVAPI int CALLCONV
cmFastStartChannelsAckIndex(	HCALL hsCall,int index,cmTransportAddress *rtcp,cmTransportAddress *rtp);

RVAPI int CALLCONV
cmFastStartChannelsAck(	HCALL hsCall,
                      IN  cmFastStartChannel *pFastChannel);

RVAPI int CALLCONV
cmFastStartOpenChannels(HCALL hsCall,cmFastStartMessage *fsMessage);

RVAPI int CALLCONV
cmFastStartChannelsReady(	HCALL hsCall);

#endif
#endif
#ifdef __cplusplus
}              
#endif



