/*
***********************************************************************************

NOTICE:
This document contains information that is proprietary to RADVision LTD..
No part of this publication may be reproduced in any form whatsoever without 
written prior approval by RADVision LTD..

RADVision LTD. reserves the right to revise this publication and make changes 
without obligation to notify any person of such revisions or changes.

***********************************************************************************
*/

/*
  ti.h

  Ron S. 29 Nov. 1995
  Revised 18 Aug. 1996 by ron.
  
  Low level timing mechanism.
  Machine dependant.

  Handle ONE timer.
  Repeated called to timerSet will override the previous calls.
  timeout interval is in mili-seconds.

*/

#ifndef _MTIH_
#define _MTIH_

#include <rvcommon.h>
DECLARE_OPAQUE(HTI);
DECLARE_OPAQUE(HSTIMER);
DECLARE_OPAQUE(HAPPTIMER);
typedef void(CALLCONV*LPMTIMEREVENTHANDLER)(void* context);


RVAPI HSTIMER CALLCONV 
mtimerInit(int maxTimers, HAPPTIMER appHndl);

RVAPI int CALLCONV 
mtimerEnd(HSTIMER timer);


RVAPI int CALLCONV 
mtimerEndByHandle(HAPPTIMER appHndl);


RVAPI HTI CALLCONV 
mtimerSet(
	 HSTIMER timer,
	 LPMTIMEREVENTHANDLER eventHandler,
	 void* context,
	 UINT32 timeOut  /* 1 msec units */
	 );

RVAPI HTI CALLCONV 
mtimerSetByHandle(
		 HAPPTIMER appHndl,
		 LPMTIMEREVENTHANDLER eventHandler,
		 void* context,
		 UINT32 timeOut
		 );
RVAPI int CALLCONV 
mtimerResetByValue(
		  HSTIMER timer,
		  LPMTIMEREVENTHANDLER eventHandler,
		  void* context
		  );


RVAPI int CALLCONV 
mtimerResetByHandle(
		  HAPPTIMER  appHndl,
		  HTI tElem
		  );
RVAPI int CALLCONV 
mtimerReset(
	   HSTIMER timer,
	   HTI tElem
	   );

#endif
