#ifdef __cplusplus
extern "C" {
#endif



#ifndef SSE_H
#define SSE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <rvcommon.h>
#include <h450.h>

DECLARE_OPAQUE(HSSEAPP);
DECLARE_OPAQUE(HSSEAPPAPP);
DECLARE_OPAQUE(HSSECALL);
DECLARE_OPAQUE(HSSEAPPCALL);


typedef int 
    (CALLCONV *sseEvForwardActivatedT)(
		IN      HSSEAPPCALL	    hSSEaCall,
		IN      HSSECALL	    hSSECall);


typedef int 
    (CALLCONV *sseEvForwardDeactivatedT)(
		IN      HSSEAPPCALL	    hSSEaCall,
		IN      HSSECALL	    hSSECall);
typedef int 
    (CALLCONV *sseEvCallTransferT)(
    		IN	HSSEAPPCALL	    hSSEaCallPri,
		IN      HSSECALL	    hSSECallPri,
		OUT	HSSECALL*	    hSSECallSec);

typedef int 
    (CALLCONV *sseEvCallRerouteT)(
    		IN	HSSEAPPCALL	    hSSEaCallPri,
		IN      HSSECALL	    hSSECallPri,
		OUT	HSSECALL*	    hSSECallSec);

typedef  struct 
{
    sseEvForwardActivatedT	sseEvForwardActivated;
    sseEvForwardDeactivatedT	sseEvForwardDeactivated;
    sseEvCallTransferT		sseEvCallTransfer;
    sseEvCallRerouteT		sseEvCallReroute;
} SSSECALLEVENT,*SSECALLEVENT;


typedef enum
{
    cfu_p   = 0, 
    cfb_p   = 1, 
    cfnr_p  = 2 
}   proc_e;

typedef enum
{
    unknown_r = 0,
    cfu_r     = 1, 
    cfb_r     = 2, 
    cfnr_r    = 3 
}   reason_e;


RVAPI
int CALLCONV sseEAtoStr(HSSAPP hSSApp,int eaNodeId, char *str, int len);

RVAPI
int CALLCONV sseStrtoEA(char *str,HSSAPP hSSApp,int eaNodeId);



RVAPI 
int CALLCONV sseInit( IN      char*	  name,
                      OUT     HSSEAPP*    hSSEApp,
                      IN      HSSEAPPAPP  hSSEaApp,
		      IN      HAPP	  hApp,	
		      IN      int	  maxCalls);

RVAPI 
int CALLCONV sseEnd( IN	    HSSEAPP    hSSEApp);

RVAPI 
int CALLCONV sseSetCallEventHandler(
                            IN      HSSEAPP	 hSSEApp,
                            IN      SSECALLEVENT sseCallEvent,
		            IN      int          size);

RVAPI 
int CALLCONV sseGetCallEventHandler(
                            IN      HSSEAPP      hSSEApp,
                            OUT     SSECALLEVENT sseCallEvent,
		            IN      int          size);

RVAPI
int CALLCONV sseCreateCall(
			IN      HSSEAPP		    hSSEApp,
			OUT	HSSECALL*	    hSSECall,
			IN	HSSEAPPCALL	    hSSEaCall,
			IN	HCALL		    hCall);

RVAPI 
int CALLCONV sseCallClose(
			  IN	HSSECALL	    hSSECall);

RVAPI
int CALLCONV sseImplementTransfer(
			  IN	HSSECALL	    hSSECall);

RVAPI
int CALLCONV sseCallImplementForward(IN    HSSECALL	hSSECall);


RVAPI
int CALLCONV sseCallH450SupplServ(
			IN	HSSECALL	    hSSECall, 
			IN	cmCallQ931MsgType   msgType,
			IN	int		    nodeId,
			IN	int		    size);

RVAPI
int CALLCONV sseCallImplementForwardServer(IN	HSSECALL	hSSECall);

RVAPI
int     CALLCONV sseCallStateChanged(
		IN      HSSECALL        hSSECall,    
		IN      UINT32          state,
		IN      UINT32          stateMode);

RVAPI 
int CALLCONV sseCallTransfer(HSSECALL hPri,HSSECALL hSec, char* destAddress);


RVAPI 
int CALLCONV sseCallAssociateForTransfer(HSSECALL hPri,HSSECALL hSec);

RVAPI 
int CALLCONV sseForwardActivate(IN	HSSECALL	hSSECall, 
				IN	char*		destAddr,
				IN	proc_e		proc,
				IN	char*		servAddr, 
				IN	char*		actAddr,
				IN	char*		serverAddr);
RVAPI 
int CALLCONV sseForwardDeactivate(IN	HSSECALL	hSSECall, 
				  IN	proc_e		proc,
				  IN	char*		servAddr, 
				  IN	char*		deactAddr,
				  IN	char*		serverAddr);


RVAPI 
int CALLCONV sseCallReroute(IN	HSSECALL	hSSECall, 
			    IN	reason_e	reason,
			    IN	char*		calledAddr, 
			    IN	char*		lastReroutingNr,
			    IN	char*		callingNumber);

RVAPI
int CALLCONV sseCallImplementTransfer(IN    HSSECALL	hSSECall, 
				      IN    BOOL	primary );

RVAPI int CALLCONV sseSetDefaultAddress(
                            IN      HSSEAPP     hSSEApp,
			    IN	    char*	addr);

RVAPI HSSAPP CALLCONV sseGetSSHandle(
                            IN      HSSEAPP     hSSEApp);

#ifdef __cplusplus
}
#endif
#endif
#ifdef __cplusplus
}              
#endif



