#ifdef __cplusplus
extern "C" {
#endif

/*
***********************************************************************************

NOTICE:
This document contains information that is proprietary to RADVision LTD..
No part of this publication may be reproduced in any form whatsoever without 
written prior approval by RADVision LTD..

RADVision LTD. reserves the right to revise this publication and make changes 
without obligation to notify any person of such revisions or changes.

***********************************************************************************
*/


	
#ifndef _USER_INPUT_H
#define _USER_INPUT_H
#include <rvcommon.h>
#include <cm.h>

typedef enum 
{
  cmUserInputNonStandard=0,
  cmUserInputAlphanumeric,
  cmUserInputSupport,
  cmUserInputSignal,
  cmUserInputSignalUpdate
}cmUserInputIndication;


typedef enum
{
  cmSupportNonStandard=0,
  cmSupportBasicString,  
  cmSupportIA5String,  
  cmSupportGeneralString

}cmUserInputSupportIndication;

typedef struct 
{
  int timestamp;      /* -1 if optional; */
  int expirationTime; /* -1 if optional;*/
  int logicalChannelNumber;
}cmUserInputSignalRtpStruct;

typedef struct
{
  char signalType;
  int duration;
  cmUserInputSignalRtpStruct cmUserInputSignalRtp;/* if logicalchannel == 0 -optional*/
}cmUserInputSignalStruct;

typedef struct
{
  int duration;
  cmUserInputSignalRtpStruct cmUserInputSignalRtp;
  /* if logicalchannel == 0 -optional only logicalchannel element is used */
}cmUserInputSignalUpdateStruct;


RVAPI int CALLCONV  /* userInput message node id or ERROR */
cmUserInputSupportIndicationBuild(
			     /* Build userUser message with alphanumeric data */
			     IN  HAPP hApp,
			     IN cmUserInputSupportIndication userInputSupport,
           OUT int * nodeId  /* nodeId of nonstandart UserInputSupportIndication */
			     );
RVAPI int CALLCONV  /* userInput message node id or ERROR */
cmUserInputSignalBuild(
			     /* Build userUser message with alphanumeric data */
			     IN  HAPP hApp,
			     cmUserInputSignalStruct *userInputSignalStruct
			     );
RVAPI int CALLCONV  /* TRUE or ERROR */
cmUserInputGetDetail(
	       IN  HAPP hApp,
	       IN  INT32 userInputId,
         OUT cmUserInputIndication * userInputIndication 
	       );
RVAPI int CALLCONV  
cmUserInputGetSignal(
	       IN  HAPP hApp,
	       IN  INT32 signalUserInputId,
         OUT cmUserInputSignalStruct * userInputSignalStruct
	       );
RVAPI int CALLCONV  
cmUserInputGetSignalUpdate(
	       IN  HAPP hApp,
	       IN  INT32 signalUserInputId,
         OUT cmUserInputSignalStruct * userInputSignalStruct
	       );
RVAPI int CALLCONV  
cmUserInputSupportGet(
	       IN  HAPP hApp,
	       IN  INT32 supportUserInputId,
         OUT cmUserInputSupportIndication * userInputSupportIndication
 	       );




#endif
#ifdef __cplusplus
}              
#endif



